/* Fake CGI WMS server : always return a 1024x1024 JPEG black image */
/* To be compiled as wms.cgi */

#include <stdlib.h>
#include <stdio.h>
#include <gdal.h>
#include <cpl_vsi.h>

int main(int argc, char* argv[])
{
    GDALAllRegister();
    printf("Content-Type: image/jpeg\n\n");

    GDALDatasetH hSrcDS = GDALCreate(GDALGetDriverByName("GTiff"), "/vsimem/src.tif",
                                     1024, 1024, 3, GDT_Byte, NULL);
    GDALDatasetH hDstDS = GDALCreateCopy( GDALGetDriverByName("JPEG"), "/vsimem/dst.jpg", hSrcDS,
                                          FALSE, NULL, NULL, NULL);
    GDALClose(hSrcDS);
    GDALClose(hDstDS);

    vsi_l_offset nDataLength;
    GByte* pBuffer = VSIGetMemFileBuffer("/vsimem/dst.jpg", &nDataLength, FALSE);
    fwrite(pBuffer, 1, nDataLength, stdout);

    VSIUnlink("/vsimem/dst.jpg");
    VSIUnlink("/vsimem/src.tif");

    return 0;
}
